﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Media;

using WFFont = System.Drawing.Font;

namespace JacekMatulewski.WpfUtils
{
    public struct Font
    {
        public FontFamily Family { get; set; } //auto-implemented property
        public string FamilyName
        {
            get
            {
                return Family.ToString();
            }
            /*
            set
            {
                Family = new FontFamily(value);
            }
            */
        }

        public FontStyle Style { get; set; }
        public FontWeight Weight { get; set; }
        public TextDecorationCollection TextDecorations { get; set; }
        public double Size { get; set; }
        public Color Color { get; set; }
        
        public static Font Default
        {
            get
            {
                return new Font()
                {
                    Family = new FontFamily("Segoe UI"),
                    Style = FontStyles.Normal,
                    Weight = FontWeights.Normal,
                    TextDecorations = null,
                    Size = 12,
                    Color = Colors.Black
                };
            }
        }

        public static WFFont ToSystemDrawingFont(Font font)
        {
            System.Drawing.FontStyle style = (font.Style == FontStyles.Italic) ? System.Drawing.FontStyle.Italic : System.Drawing.FontStyle.Regular;
            if (font.Weight == FontWeights.Bold) style |= System.Drawing.FontStyle.Bold;
            if (font.TextDecorations.Contains(System.Windows.TextDecorations.Underline[0]))
                style |= System.Drawing.FontStyle.Underline;
            if (font.TextDecorations.Contains(System.Windows.TextDecorations.Strikethrough[0]))
                style |= System.Drawing.FontStyle.Strikeout;
            WFFont _font = new WFFont(font.FamilyName, (int)font.Size, style);
            return _font;
        }
    }
}
